#include "U8glib.h"
#include <EEPROM.h>

long randNumber,data;//定义随机变量使用数据名称

//EEPROM配置
#define EEPROM_write(address, p) {int i = 0; byte *pp = (byte*)&(p);for(; i < sizeof(p); i++) EEPROM.write(address+i, pp[i]);}
#define EEPROM_read(address, p)  {int i = 0; byte *pp = (byte*)&(p);for(; i < sizeof(p); i++) pp[i]=EEPROM.read(address+i);}

U8GLIB_SSD1306_128X64 u8g(U8G_I2C_OPT_NONE);//配置OLED显示屏	
// HW SPI Com: CS = 10, A0 = 9 (Hardware Pins are  SCK = 13 and MOSI = 11)

//定义microduino图标大小
#define u8g_logo_width 128
#define u8g_logo_height 18

const unsigned char u8g_logo_bits[] U8G_PROGMEM = {
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x01,0xE0,
  0x03,0x00,0x00,0x00,0x00,0x7E,0x00,0xF0,0x01,0x00,0x00,0x00,
  0x00,0xFE,0xF9,0xF7,0x07,0x00,0x00,0x00,0x00,0x3C,0x00,0xF8,
  0x03,0x00,0x00,0x00,0x00,0xFC,0xF9,0xE1,0x03,0x00,0x00,0x00,
  0x00,0x38,0x00,0xF0,0x01,0x00,0x00,0x00,0x00,0xFC,0xFF,0x01,
  0x00,0x00,0x00,0x00,0x00,0x38,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0xFC,0xEF,0xF9,0x8F,0xD7,0x73,0xF1,0xC1,0x3B,0x9F,0xFF,
  0xFF,0x1E,0x3E,0x00,0x00,0xBC,0xEF,0xC1,0xE1,0x9F,0xFF,0xDD,
  0xE3,0x3F,0xCC,0xE1,0xF0,0xBF,0x7B,0x00,0x00,0x3C,0xF7,0xE1,
  0xE1,0x9F,0xFF,0xC6,0xF7,0x3E,0x8E,0xF3,0xF0,0xFF,0xF8,0x00,
  0x00,0x3C,0xF3,0xE1,0xF1,0x93,0xFF,0xE6,0xF7,0x3C,0x8F,0xF7,
  0xF0,0xFF,0xFC,0x00,0x00,0x7C,0xF2,0xE1,0xF1,0x83,0x87,0xFE,
  0xF7,0x39,0xFF,0xF7,0xF0,0xFF,0xFF,0x00,0x00,0x7C,0xF0,0xE3,
  0xF3,0xA3,0x03,0xFE,0xF7,0x3F,0xFF,0xF7,0x71,0xFC,0xFF,0x00,
  0x00,0x7C,0xF8,0xE3,0xF3,0xBF,0x03,0xFE,0xE3,0x3F,0xFF,0xF3,
  0x71,0xDC,0x7F,0x00,0x00,0x7E,0xFC,0xE7,0xE3,0xBF,0x03,0xFC,
  0xE3,0x3F,0xFE,0xF3,0x71,0x9C,0x7F,0x00,0x00,0xC1,0x03,0xF8,
  0xCF,0xE7,0x0F,0xF0,0x00,0x7F,0xFC,0xFC,0xFF,0x3E,0x1E,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};//microduino图标

//定义EEPROMdata
struct config_type
{
  int EEPROMdata;
};

void setup()
{
  volcdsetup("  Welcome! ",20,32);//开机显示
  delay(500);
  volcdsetup("Load EEPROM",20,32);
  delay(1000);

  /*EEPROM读取赋值*/
  config_type config_readback;
  EEPROM_read(0, config_readback);
  data= config_readback.EEPROMdata;
  //Microduino图标显示
  volcdlogo(0,20);
  delay(1000);
}
void loop()
{
  randNumber = random(10, 100);//随机函数，randNumber的值从10到99变化
  delay(1000);//每隔1s刷新一次
  if(randNumber!=data) //判断EEPROM数据是否变化，变化则写入
    eeprom_write();//EEPROM写入函数
  u8g.firstPage();
  do
  {
    draw();
  }
  while( u8g.nextPage() );
}

void draw(void)
{
  u8g.setFont(u8g_font_7x13);//字体大小
  u8g.setPrintPos(0, 32); //字体坐标
  u8g.print("Random:");
  u8g.print(randNumber);
  u8g.print("  EEP:");
  u8g.print(data);

  u8g.setFont(u8g_font_chikitar);//字体大小
  u8g.drawFrame(0, 54,128,10);//画矩形框（起点坐标（x,y）,long,high）
  u8g.setPrintPos(3, 62);    //字体坐标 
  u8g.print("Microduino-RTC v1.0  201310");
}

//=======================microduino图标显示函数===========================//
void volcdlogo(unsigned int x,unsigned int y)
{
  u8g.firstPage();  
  do {
    u8g.drawXBMP( x, y, u8g_logo_width, u8g_logo_height, u8g_logo_bits);
  } 
  while( u8g.nextPage() );
}
//=======================开机状态显示函数===========================//
void volcdsetup(char* zi,int x,int y)
{
  u8g.firstPage();  
  do {
    u8g.setFont(u8g_font_9x18Br);
    u8g.setPrintPos(x, y); 
    u8g.print(zi);
  } 
  while( u8g.nextPage() );
}

//=======================EEPROM写函数===========================//
void eeprom_write()
{
  config_type config;                  // 定义结构变量config，并定义config的内容
  config.EEPROMdata=randNumber;
  EEPROM_write(0, config);         // 变量config存储到EEPROM，地址0写入
}


